   .org  16509       ; REM code - relocator

;; de = fname pointer, with optional start,length;  a = operation.: 0 = load, 1-7f = delete, 80-ff = save
;;
api_fileop     .equ $1ff8
api_rdjoy      .equ $1ffe

   .byte 0,1         ; 1 REM ....
   .word end-rem
   
rem:
   .byte $ea

   ; ensure RAM is paged LOW on zxpand
   ;
   ld    bc,$e007
   ld    a,$b2
   out   (c),a

   ; I need to do a proper evaluation
   ; of how long the paging takes
   ;
   ld    bc,$0020
innerwait:
   dec   b
   jr    nz,innerwait
   dec   c
   jr    nz,innerwait
   
   ; go FAST
   ;
   call $02e7

   ; move code to 8K and jump there
   ;
   ld    hl,start
   ld    de,$2000
   ld    bc,end-start
   ldir
   jp    $2000


start:
   ; load the required program
   ;
   ld    de,fname-(start-$2000)
   xor   a
   call  api_fileop

   ; we can't return to the old program now, so clean up the stack
   ;
   ld    hl,($4002)     ; ERR-SP
   ld    sp,hl

   ; calculate crc of the loaded file
   ;
   ld    hl,$4009
   ld    bc,(flen-(start-$2000))
   ld    de,$ffff
   call  crc16-(start-$2000)

   ; return to basic if crc doesn't match expected value
   ;
   ld    hl,(fcrc-(start-$2000))
   and   a
   sbc   hl,de
   jr    z,continue

   :(
   
   ;todo - print msg about code being incompatible?
   jp    0


continue:   
   ; patch the program
   ;
   ld    hl,PATCH-(start-$2000)
   ld    a,$cd
   ld    ($45b9),a
   ld    ($45ba),hl
   ld    ($462a),a
   ld    ($462b),hl
   ld    ($4672),a
   ld    ($4673),hl
   
   ; start it
   ;
   jp    $0207          ; SLOW/FAST



crc16:
   push  bc

   ld    a,(hl)
   xor   d
   ld    d,a
   ld    b,8

rotlp:
   sla   e
   rl    d
   jr    nc,clear
   
   ld    a,d
   xor   $10
   ld    d,a
   ld    a,e
   xor   $21
   ld    e,a

clear:
   dec b
   jr    nz,rotlp

   inc   hl
   pop   bc
   dec   bc
   ld    a,b
   or    c
   jr    nz,crc16

   ret



PATCH:
   push  bc
   push  hl
   ld    a,($4025)
   ld    h,a
   call  api_rdjoy      ; JOYSTK

   bit   7,a
   jr    nz,notup

   res   1,h

notup:
   bit   6,a
   jr    nz,notdown

   res   0,h

notdown:
   bit   4,a
   jr    nz,notright

   res   7,h

notright:
   bit   3,a
   jr    nz,notfire

   res   6,h

notfire:
   ld    a,h
   pop   hl
   pop   bc
   ret


fname:   .byte $35, $37, $34, $39, $2a, $28, $39, $37, $1b, $b5 ; 'PROTECTR.P'
flen:    .word 7601
fcrc:    .word 24979



   .byte $76


end:
  
   .end
